#Calculating the sleep phenotypes, sleep duration and midpoints - social lags is left for R in the circular package
#Input: SleepDataTrim.csv
#Output: SleepDataTrimMetrics.csv

import pandas as pd
import numpy as np

Chrono = pd.read_csv('SleepDataTrim.csv')

def SleepMetrics(DF):
    
    #Sleep Duration
    if DF['Weekday.Bed.Time'] >= 12.0 and DF['Weekday.Wake.Time'] >= 12.0:
        if DF['Weekday.Wake.Time'] - DF['Weekday.Bed.Time'] < 0:
            DF['Weekday.Sleep.Duration'] = np.abs((24 - DF['Weekday.Bed.Time']) + DF['Weekday.Wake.Time'])
        else:
            DF['Weekday.Sleep.Duration'] = np.abs(DF['Weekday.Bed.Time'] - DF['Weekday.Wake.Time'])
    if DF['Weekend.Bed.Time'] >= 12.0 and DF['Weekend.Wake.Time'] >= 12.0:
        if DF['Weekend.Wake.Time'] - DF['Weekend.Bed.Time'] < 0:
            DF['Weekend.Sleep.Duration'] = np.abs((24 - DF['Weekend.Bed.Time']) + DF['Weekend.Wake.Time'])
        else:
            DF['Weekend.Sleep.Duration'] = np.abs(DF['Weekend.Bed.Time'] - DF['Weekend.Wake.Time'])    
    if DF['Weekday.Bed.Time'] >= 12.0 and DF['Weekday.Wake.Time'] < 12.0:
        DF['Weekday.Sleep.Duration'] = (24 - DF['Weekday.Bed.Time']) + DF['Weekday.Wake.Time']
    if DF['Weekend.Bed.Time'] >= 12.0 and DF['Weekend.Wake.Time'] < 12.0:
        DF['Weekend.Sleep.Duration'] = (24 - DF['Weekend.Bed.Time']) + DF['Weekend.Wake.Time']
    if DF['Weekday.Bed.Time'] < 12.0:
        DF['Weekday.Sleep.Duration'] = np.abs(DF['Weekday.Bed.Time'] - DF['Weekday.Wake.Time'])
    if DF['Weekend.Bed.Time'] < 12.0:
        DF['Weekend.Sleep.Duration'] = np.abs(DF['Weekend.Bed.Time'] - DF['Weekend.Wake.Time'])
        
    #Sleep midpoint
    if DF['Weekday.Bed.Time'] >= 12.0 and DF['Weekday.Wake.Time'] >= 12.0:
        if DF['Weekday.Wake.Time'] - DF['Weekday.Bed.Time'] < 0:
            Avg = np.abs((24 - DF['Weekday.Bed.Time']) + DF['Weekday.Wake.Time'])/2
            DF['Weekday.Sleep.Midpoint'] = DF['Weekday.Wake.Time'] - Avg
        else:
            DF['Weekday.Sleep.Duration'] = np.abs(DF['Weekday.Bed.Time'] - DF['Weekday.Wake.Time'])
    if DF['Weekend.Bed.Time'] >= 12.0 and DF['Weekend.Wake.Time'] >= 12.0:
        if DF['Weekend.Wake.Time'] - DF['Weekend.Bed.Time'] < 0:
            Avg = np.abs((24 - DF['Weekend.Bed.Time']) + DF['Weekend.Wake.Time'])/2
            DF['Weekend.Sleep.Midpoint'] = DF['Weekend.Wake.Time'] - Avg
        else:
            DF['Weekend.Sleep.Duration'] = np.abs(DF['Weekend.Bed.Time'] - DF['Weekend.Wake.Time'])
    if DF['Weekday.Bed.Time'] >= 12.0 and DF['Weekday.Wake.Time'] < 12.0:
        Avg = ((24 - DF['Weekday.Bed.Time']) + DF['Weekday.Wake.Time'])/2
        DF['Weekday.Sleep.Midpoint'] = DF['Weekday.Bed.Time'] + Avg
        if DF['Weekday.Sleep.Midpoint'] > 24:
            DF['Weekday.Sleep.Midpoint'] = DF['Weekday.Sleep.Midpoint'] - 24
    if DF['Weekend.Bed.Time'] >= 12.0 and DF['Weekend.Wake.Time'] < 12.0:
        Avg = ((24 - DF['Weekend.Bed.Time']) + DF['Weekend.Wake.Time'])/2
        DF['Weekend.Sleep.Midpoint'] = DF['Weekend.Bed.Time'] + Avg
        if DF['Weekend.Sleep.Midpoint'] > 24:
            DF['Weekend.Sleep.Midpoint'] = DF['Weekend.Sleep.Midpoint'] - 24
    if DF['Weekday.Bed.Time'] < 12.0:
        Avg = np.abs(DF['Weekday.Bed.Time'] - DF['Weekday.Wake.Time'])/2
        DF['Weekday.Sleep.Midpoint'] = np.abs(DF['Weekday.Bed.Time'] + Avg)
    if DF['Weekend.Bed.Time'] < 12.0:
        Avg = np.abs(DF['Weekend.Bed.Time'] - DF['Weekend.Wake.Time'])/2
        DF['Weekend.Sleep.Midpoint'] = np.abs(DF['Weekend.Bed.Time'] + Avg)

    return(DF)

ChronoMets = Chrono.apply(SleepMetrics, axis = 1)

#Remove long sleepers (>18hrs)
ChronoMets = ChronoMets[~(ChronoMets['Weekday.Sleep.Duration'] >= 18)]
ChronoMets = ChronoMets[~(ChronoMets['Weekend.Sleep.Duration'] >= 18)]

ChronoMets.to_csv('SleepDataTrimMetrics.csv')

