#Input: SleepDataClean.csv
#Output: FigS1.pdf
library(readr)
library(ggplot2)
library(ggthemes)

#filepath = file.path('..')
filepath = getwd()

dir.create(path = file.path(filepath, 'RecordSummaries'))


#Read in sleep phenotypes
Chrono = read_csv(file = file.path(filepath, 'SleepDataClean.csv'))

#Supplementary figure - histogram of visit years
VisitYearGG = ggplot(Chrono, aes(x = Year)) +
  theme_bw()+
  xlim(c(2000, 2017))+
  ylim(c(0, 600))+
  ylab('Number of visits')+
  geom_histogram(binwidth = 1)+
  theme(axis.text = element_text(size = 14), axis.title = element_text(size = 16, face = "bold"), legend.title = element_blank())
ggsave(filename = "FigS1.pdf", plot = VisitYearGG, path = file.path(filepath, 'RecordSummaries'), width = 6, height = 5)
