#Objective - extract phecodes for each individual, ensuring a minimum of 2 mentions
#Inputs: SleepDataClean.csv, GRID_AllPhecodeByVisit
#Outputs: GridPhecodes_Min2Cases.csv
import pandas as pd
import numpy as np

Chrono = pd.read_csv('SleepDataClean.csv')

GRIDs = list(set(Chrono.GRID))

GRIDCodes = pd.read_csv('GRID_AllPhecodeByVisit')

Phecodes = list(set(GRIDCodes.PHECODE))

#Trim down to the rows which contain a GRID from your cohort
GRIDCodes = GRIDCodes[GRIDCodes.GRID.isin(GRIDs)]

GridCodesGroup = [x for x in list(GRIDCodes.groupby(['GRID']))]

Names = ['GRID'] + Phecodes

GridSnpMat = pd.DataFrame(np.zeros((len(GRIDs), len(Names))))
GridSnpMat.columns = Names
GridSnpMat.GRID = GRIDs

Grid = GridCodesGroup[0][0]
Codes = GridCodesGroup[0][1].PHECODE.values

Output = pd.DataFrame()
for GridSet in GridCodesGroup:
    #New
    Grid = GridSet[0]
    Codes = GridSet[1][GridSet[1].PHECODE.duplicated(keep = False)].PHECODE.values
    #Ensuring that the phecode comes up at least twice on separate visits!
    Codes = list(set([x for x in Codes if len(set(GridSet[1].ENTRY_DATE[GridSet[1].PHECODE == x])) > 1]))
    #Case vs. control - if only one mention of the code, we don't consider it a case nor control, and set to na
    NACodes = list(set([x for x in Codes if len(set(GridSet[1].ENTRY_DATE[GridSet[1].PHECODE == x])) == 1]))
    minimini = pd.Series(GridSnpMat.iloc[GridSnpMat[GridSnpMat.GRID == Grid].index].values[0])
    for code in Codes:
        minimini.values[GridSnpMat.columns.get_loc(code)] = 1
    for code in NACodes:
        minimini.values[GridSnpMat.columns.get_loc(code)] = 'NaN'
    minimini = pd.DataFrame(minimini).T
    Output = Output.append(minimini)

Output.columns=Names #Retrieve phecode IDs

Output.to_csv('GridPheCodes_Min2Cases.csv')
